/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables


import cc.cinnamon.canary.users.model.Keys
import cc.cinnamon.canary.users.model.Public
import org.jooq.*
import org.jooq.impl.TableImpl

import javax.annotation.Generated
import java.sql.Date
import java.sql.Timestamp
import java.util.Arrays


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class Users private constructor(alias: String, aliased: Table<Record>, parameters: Array<Field<*>>? = null) : TableImpl<Record>(alias, null, aliased, parameters, "") {

    /**
     * The class holding records for this type
     */
    override fun getRecordType(): Class<Record> {
        return Record::class.java
    }

    /**
     * The column `public.users.id`.
     */
    val ID = AbstractTable.createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('users_id_seq'::regclass)", org.jooq.impl.SQLDataType.BIGINT)), this, "")

    /**
     * The column `public.users.name`.
     */
    val NAME = AbstractTable.createField("name", org.jooq.impl.SQLDataType.VARCHAR.length(200).nullable(false), this, "")

    /**
     * The column `public.users.password`.
     */
    val PASSWORD = AbstractTable.createField("password", org.jooq.impl.SQLDataType.VARCHAR.length(512).nullable(false), this, "")

    /**
     * The column `public.users.email`.
     */
    val EMAIL = AbstractTable.createField("email", org.jooq.impl.SQLDataType.VARCHAR.length(254), this, "")

    /**
     * The column `public.users.age`.
     */
    val AGE = AbstractTable.createField("age", org.jooq.impl.SQLDataType.INTEGER.defaultValue(org.jooq.impl.DSL.field("18", org.jooq.impl.SQLDataType.INTEGER)), this, "")

    /**
     * The column `public.users.city`.
     */
    val CITY = AbstractTable.createField("city", org.jooq.impl.SQLDataType.VARCHAR.length(122), this, "")

    /**
     * The column `public.users.location`.
     */
    val LOCATION = AbstractTable.createField("location", org.jooq.impl.DefaultDataType.getDefaultDataType("USER-DEFINED"), this, "")

    /**
     * The column `public.users.birthday`.
     */
    val BIRTHDAY = AbstractTable.createField("birthday", org.jooq.impl.SQLDataType.DATE, this, "")

    /**
     * The column `public.users.created_stamp`.
     */
    val CREATED_STAMP = AbstractTable.createField("created_stamp", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaultValue(org.jooq.impl.DSL.field("now()", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "")

    /**
     * The column `public.users.active`.
     */
    val ACTIVE = AbstractTable.createField("active", org.jooq.impl.SQLDataType.BOOLEAN.nullable(false).defaultValue(org.jooq.impl.DSL.field("true", org.jooq.impl.SQLDataType.BOOLEAN)), this, "")

    /**
     * Create a `public.users` table reference
     */
    constructor() : this("users", null) {
    }

    /**
     * Create an aliased `public.users` table reference
     */
    constructor(alias: String) : this(alias, USERS) {
    }

    /**
     * {@inheritDoc}
     */
    override fun getSchema(): Schema {
        return Public.PUBLIC
    }

    /**
     * {@inheritDoc}
     */
    override fun getIdentity(): Identity<Record, Long> {
        return Keys.IDENTITY_USERS
    }

    /**
     * {@inheritDoc}
     */
    override fun getPrimaryKey(): UniqueKey<Record> {
        return Keys.USERS_PKEY
    }

    /**
     * {@inheritDoc}
     */
    override fun getKeys(): List<UniqueKey<Record>> {
        return Arrays.asList(Keys.USERS_PKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun `as`(alias: String): Users {
        return Users(alias, this)
    }

    /**
     * Rename this table
     */
    override fun rename(name: String): Users {
        return Users(name, null)
    }

    companion object {

        private val serialVersionUID: Long = 1382855602

        /**
         * The reference instance of `public.users`
         */
        val USERS = Users()
    }
}
